
( function ( blocks, element, blockEditor ) {
    const el = element.createElement,
        registerBlockType = blocks.registerBlockType,
        ServerSideRender = PgServerSideRender,
        InspectorControls = blockEditor.InspectorControls,
        useBlockProps = blockEditor.useBlockProps;
        
    const {__} = wp.i18n;
    const {ColorPicker, TextControl, ToggleControl, SelectControl, Panel, PanelBody, Disabled, TextareaControl, BaseControl} = wp.components;
    const {useSelect} = wp.data;
    const {RawHTML, Fragment} = element;
   
    const {InnerBlocks, URLInputButton, RichText} = wp.blockEditor;
    const useInnerBlocksProps = blockEditor.useInnerBlocksProps || blockEditor.__experimentalUseInnerBlocksProps;
    
    const propOrDefault = function(val, prop, field) {
        if(block.attributes[prop] && (val === null || val === '')) {
            return field ? block.attributes[prop].default[field] : block.attributes[prop].default;
        }
        return val;
    }
    
    const block = registerBlockType( 'flexwebsite/logos', {
        apiVersion: 2,
        title: 'Logos',
        icon: 'block-default',
        category: 'flex',
        keywords: [],
        supports: {color: {background: false,text: false,gradients: false,link: false,},typography: {fontSize: false,},anchor: false,align: false,},
        attributes: {
            section_id: {
                type: 'text',
                default: '',
            },
            text: {
                type: 'text',
                default: `Trusted by the top companies in this industry`,
            }
        },
        example: { attributes: { section_id: '', text: `Trusted by the top companies in this industry` } },
        edit: function ( props ) {
            const blockProps = useBlockProps({ className: 'py-20 xl:pt-24 bg-white', style: { backgroundPosition: 'center',backgroundImage: 'url(\'' + (pg_project_data_flexwebsite ? pg_project_data_flexwebsite.url : '') + 'images/pattern-white.svg\')' }, id: propOrDefault( props.attributes.section_id, 'section_id' ) });
            const setAttributes = props.setAttributes; 
            
            
            const innerBlocksProps = useInnerBlocksProps({ className: 'flex flex-wrap justify-center -mx-4' }, {
                allowedBlocks: [ 'flexwebsite/logo' ],
                template: [
    [ 'flexwebsite/logo', {} ],
    [ 'flexwebsite/logo', {} ],
    [ 'flexwebsite/logo', {} ],
    [ 'flexwebsite/logo', {} ],
    [ 'flexwebsite/logo', {} ]
],
            } );
                            
            
            return el(Fragment, {}, [
                el('section', { ...blockProps }, el('div', { className: 'container px-4 mx-auto' }, [el(RichText, { tagName: 'h3', className: 'mb-8 text-center font-medium leading-6 text-coolGray-300', value: propOrDefault( props.attributes.text, 'text' ), onChange: function(val) { setAttributes( {text: val }) }, withoutInteractiveFormatting: true, allowedFormats: [] }), el('div', { ...innerBlocksProps })])),                        
                
                    el( InspectorControls, {},
                        [
                            
                            el(Panel, {},
                                el(PanelBody, {
                                    title: __('Block properties')
                                }, [
                                    
                                    el(TextControl, {
                                        value: props.attributes.section_id,
                                        help: __( '' ),
                                        label: __( 'Section id' ),
                                        onChange: function(val) { setAttributes({section_id: val}) },
                                        type: 'text'
                                    }),
                                    el(TextControl, {
                                        value: props.attributes.text,
                                        help: __( '' ),
                                        label: __( 'Text' ),
                                        onChange: function(val) { setAttributes({text: val}) },
                                        type: 'text'
                                    }),    
                                ])
                            )
                        ]
                    )                            

            ]);
        },

        save: function(props) {
            const blockProps = useBlockProps.save({ className: 'py-20 xl:pt-24 bg-white', style: { backgroundPosition: 'center',backgroundImage: 'url(\'' + (pg_project_data_flexwebsite ? pg_project_data_flexwebsite.url : '') + 'images/pattern-white.svg\')' }, id: propOrDefault( props.attributes.section_id, 'section_id' ) });
            return el('section', { ...blockProps }, el('div', { className: 'container px-4 mx-auto' }, [el(RichText.Content, { tagName: 'h3', className: 'mb-8 text-center font-medium leading-6 text-coolGray-300', value: propOrDefault( props.attributes.text, 'text' ) }), el('div', { className: 'flex flex-wrap justify-center -mx-4' }, el(InnerBlocks.Content, { allowedBlocks: [ 'flexwebsite/logo' ] }))]));
        }                        

    } );
} )(
    window.wp.blocks,
    window.wp.element,
    window.wp.blockEditor
);                        
